// Test Chameleon V1.5 FET switch Q1, Q2

//#define TRACE	//define this is you need jtag tracing
#include "../Gecko_library/include/CDC_api.h"
#include "../Gecko_library/include/AVR_Chameleon_V1.5.h"	//hardware description
#include "adc_drv.h"

#define VTARGET_ADC_CHANNEL 1

u08 buf[10];

u08 ReadSignature()
{
u08 bit,i;
u08 signature=0;
	ResetSignature();
	for(i=0;i<8;i++){
		SIGCK_High();
		SIGCK_Low();
		bit = SO_read();
		usb_putchar(bit+'0');
		if(bit == 0){
			signature = signature<<1;
		}else{
			signature = (signature<<1)|bit;
		}
	}
	return signature;
}



//connect USB driver to stdio
FILE usb_str = FDEV_SETUP_STREAM(usb_std_putchar, usb_std_getchar, _FDEV_SETUP_RW);

int main(void)
{
char input_buf[3];
	usb_init(16, 0x03EB,0x2021);						//start usb timers and tasks
//	PgmInit();
	PwrInit();
	PgmOn();
	DDRB |= 1<<1 | 1<<0;								//Q2 Q1 gate 

//ADC init
	Right_adjust_adc_result();	
	Disable_adc_high_speed_mode();
	Disable_adc_int();
	Set_prescaler(5);						//2**5 = 32 divisor
	Enable_vcc_vref();						//use AVCC as reference
	Enable_adc();							//ADC on so  Vref is stable


	MCUCR |= 1<<JTD;
	MCUCR |= 1<<JTD;									//disable PORTF jtag 

	InitSignature();
	usb_putchar(usb_getchar());
	stdout = stdin = stderr = &usb_str;					//connect I/O stream
	printf_P(PSTR("\nChameleon V1.5 Test of Fets\n"));	//printf from flash
	while(1){
      	printf_P(PSTR("Enter command: "));
		input_buf[0] = usb_getchar();
		printf("%c\n", input_buf[0]);
		switch(input_buf[0]){
		case '?':
			printf_P(PSTR("Commands:\n"));
			printf_P(PSTR("  1 Q2 GND on\n"));
			printf_P(PSTR("  2 Q2 GND off\n"));
			printf_P(PSTR("  3 Q1 PWR off\n"));
			printf_P(PSTR("  4 Q1 PWR on\n"));
			printf_P(PSTR("  5 Toggle PWR\n"));
//			printf_P(PSTR("  6 Toggle PGM\n"));
			printf_P(PSTR("  7 Read ADC\n"));
			printf_P(PSTR("  8 Read PF7..4\n"));
			printf_P(PSTR("  s Read CPLD signature\n"));
			printf_P(PSTR("  ? this menu\n"));
			break;

		case '1':				//
			PORTB |= 1<<1;
			printf_P(PSTR("Q2 GND on\n"));
	  		break;
		case '2':				//
			PORTB &= ~(1<<1);
			printf_P(PSTR("Q2 GND off\n"));
	  		break;
		case '3':				//
			PORTB |= 1<<0;
			printf_P(PSTR("Q1 PWR off\n"));
	  		break;
		case '4':				//
			PORTB &= ~(1<<0);
			printf_P(PSTR("Q1 PWR on\n"));
	  		break;
		case '5':				//
			DDRF |= 1<<7;										//PF7 output
			PwrToggle();
			printf_P(PSTR("Toggle PWR\n"));
	  		break;
//		case '6':				//
//			PgmToggle();
//			printf_P(PSTR("Toggle PGM\n"));
//	  		break;
		case '7':				//ADC1
			Start_conv_channel(VTARGET_ADC_CHANNEL);//Start conversion
			while(WaitADC());		//wait 
			printf_P(PSTR("ADC = %d "),(u16)Adc_10bit());
			printf_P(PSTR("Vtarget = %d mV\n"),100*((5*10*Adc_10bit())/1024));
	  		break;
		case '8':				//
			DDRF &= ~(0xf0);									//PF4-7 input
			printf_P(PSTR("PF7 = %d "),(PINF & 1<<7)>>7);
			printf_P(PSTR("PF6 = %d "),(PINF & 1<<6)>>6);
			printf_P(PSTR("PF5 = %d "),(PINF & 1<<5)>>5);
			printf_P(PSTR("PF4 = %d\n"),(PINF & 1<<4)>>4);
	  		break;
		case 's':				//Signature
			printf_P(PSTR(" 0x%x\n"),ReadSignature());
			PwrToggle();
	  		break;
						
		default:
	  		printf_P(PSTR("Unknown command: %s\n"), buf);
	  		break;
		}			
	}
}



