//
// LA8_V1.1 - A program to test read the FPGA signature byte.
// Copyright (C) 2009 Doug Commons
//
#include "../Gecko_library/include/usb_descriptors.h"
#include "../Gecko_library/include/LA8_V1.1.h"			//hardware definition
#include "../Gecko_library/include/CDC_api.h"			//CDC support

//connect USB driver to stdio
FILE usb_str = FDEV_SETUP_STREAM(usb_std_putchar, usb_std_getchar, _FDEV_SETUP_RW);

#define DM	0
#define DP	1
#define RDY	2
#define RD	3
#define FRST 4

u08 ReadSignature()
{
u08 bit,i;
u08 signature=0;
	ResetSignature();
	for(i=0;i<8;i++){
		SIGCK_High();
		SIGCK_Low();
		bit = SO_read();
		usb_putchar(bit+'0');
		if(bit == 0){
			signature = signature<<1;
		}else{
			signature = (signature<<1)|bit;
		}
	}
	return signature;
}

u08 buf[32];
unsigned char rdy,past,current;
int i;

int main(void)
{
	usb_init(16,0x03EB,0x2021);							//start usb timers and tasks
	Pgm1Init();
	Pgm1On();
	CDC_init();
	usb_putchar(usb_getchar());							//wait for host to be ready
	stdout = stdin = stderr = &usb_str;					//connect I/O stream
	printf_P(PSTR("\nLA Signature test.\n"));			//printf from flash

	InitSignature();

	MCUCR |= 1<<JTD;
	MCUCR |= 1<<JTD;									//disable PORTF jtag 
	DDRF |= (1<<FRST);									//FPGA rst output
	PORTF &= ~(1<<FRST);								//reset pulse
	asm volatile ("nop");
	asm volatile ("nop");
	PORTF |= (1<<FRST);
	printf_P(PSTR("Reset = %d\n"),(PINF & 1<<FRST)>>FRST);


	DDRD &= ~(1<<DP | 1<<DM | 1<<RDY);					//inputs
	DDRD |= 1<<RD;										//outputs
	while(1){
		printf_P(PSTR(" 0x%x\n"),ReadSignature());
		Pgm1Toggle();								
		
/*		printf_P(PSTR(" ready = %d\n"),rdy);
		past = PIND & 0x03;								//PD0=D- PD1=D+
		PORTD &= ~(1<<RD);								//RD = PD3
		asm volatile ("nop");
		PORTD |= (1<<RD);
		asm volatile ("nop");
		PORTD &= ~(1<<RD);
		current = PIND & 0x03;
		printf_P(PSTR("previous = 0x%x current = 0x%x\n"),past,current);*/
		
		
		for(i=0;i<10;i++){
			while(!rdy){rdy = PIND & 1<<RDY;};
			current = PIND & 0x03;
			printf_P(PSTR("0x%x "),current);
			PORTD &= ~(1<<RD);							//RD = PD3
			asm volatile ("nop");
			PORTD |= (1<<RD);
			asm volatile ("nop");
			PORTD &= ~(1<<RD);
			current = PIND & 0x03;
			printf_P(PSTR("aft0x%x "),current);	
		}
		printf_P(PSTR("Press space key to loop again....\n"));
		while(usb_getchar() != 0x20){}
	}
}






