//-----------------------------------------------------------------------------
// Hardware-dependent code for usb_jtag
//-----------------------------------------------------------------------------
#ifndef _HW_BASIC_H
#define _HW_BASIC_H
//
//#define DEBUG
// Size of output buffer must be exactly 128
#define OUTBUFFER_LEN 128
unsigned char OutBuffer[OUTBUFFER_LEN];
unsigned int Pending, JTAG_data;

//#define SPITX
//#define SPIRX

//Two options exist for handling bit-bang operations. First the command
//bytes can be mapped to the AVR I/O and written as a single byte. This
//is very tight fast code. Second you can individually shift and write 
//the command bits as required but this is pretty slow.Use the following 
//define to select the bit bang mode.
//#define FAST_IO
#ifdef FAST_IO
#define ProgIO_Set_State(d)	JPORT = pgm_read_byte(&jtag_map[d&0x3f]);
#else 
extern void ProgIO_Set_State(unsigned char d);
#endif
extern void ProgIO_Init(void);
extern unsigned char ProgIO_Set_Get_State(unsigned char d);
extern void ProgIO_ShiftOut(unsigned char x);
extern unsigned char ProgIO_ShiftInOut(unsigned char TDI_byte);
extern void OutputByte(unsigned char data);

unsigned int INpkts,OUTpkts,JTAGclocks;
#endif // _HW_BASIC_H

