/*
 * JTAG test library
 */
#ifndef _JTAG_H_
#define _JTAG_H_

//#define V1_1	//usb16.h options for USB16 V1.1 card
//#define LA16	//usb16.h options for LA16 V1.0 card
//#define TRACE	//define this is you need jtag tracing
//#include "../include/usb16_V1.2.h"	//USB16 hardware definition
#include "../include/typedefs.h"
#include <util/delay.h>

enum state
{	Test_Logic_Reset,
	Run_Test_Idle,
	Select_DR_Scan,
	Capture_DR,
	Shift_DR,
	Exit1_DR,
	Pause_DR,
	Exit2_DR,
	Update_DR,
	Select_IR_Scan,
	Capture_IR,
	Shift_IR,
	Exit1_IR,
	Pause_IR,
	Exit2_IR,
	Update_IR
};
enum state volatile JTAG_state;

void Print_JTAG(void);
//void TestBit(u08 port, u08 bit, char* string);
void JTAG_Init(void);
void JTAG_Off(void);
void PrintCR(void);
void PrintTDO(void);
void PrintTDI(void);
void PrintTMS(void);
void PrintTCK(void);
void PrintState(u08 tms);
u08 JTAG_clock(u08 tdi, u08 tms);
void JTAG_reset_tap(void);
uint32_t JTAG_read32(void);
void JTAG_shift_IR(void);
void JTAG_shift_DR(void);
u08 JTAG_detect_length(void);
void JTAG_report_IDCODE(void);

#endif



