// HID_api.h
//
// This file contains the control endpoint functions corresponding to
// the HID enumeration process.

#ifndef _HID_API_H_
#define _HID_API_H_
//_____ I N C L U D E S ____________________________________________________
#include "usb_descriptors.h"
#include "usb_standard_request.h"
#include <avr/eeprom.h>

//HID internal functions
u08 	usb_HID_request(u08* type, u08* request);
void 	HID_Init(void);
void   	hid_get_report(void);
void   	hid_set_report(void);
void   	usb_hid_get_interface(void);
void 	usb_user_request_callback(void * fct);
void 	hid_host_write_word(void);

//_____ D E C L A R A T I O N ______________________________________________
u08 bmRequestType;
u16 wValue,wIndex,wLength;
u08	bmRequest;
u08 keyValues[2];

// HID specific
#define hid                   				0x21
#define REPORT                				0x22
#define SET_REPORT			  				0x02
// HID requests for changing key values and for RESET 
#define REQ_KeyValues						0xAD

#endif  // _HID_API_H_

