//SmartKeyV1.0.h
//___________________USB16 Crystal definition_____________________________ 
#ifndef F_CPU
#define F_CPU 16000000
#endif

//___________________USB16 LED definition_________________________________
//Led Cathode bits and J1-5 Cathode bits
#define LED1C			6
#define LED2C			5
#define LED3C			4

//Led Anode bits and J1-5 anode bits
#define LED1 			7
#define LED2 			6
#define LED3 			5

#define LedCPort		PORTC				//port for Led cathode
#define LedCDDR			DDRC
#define LedPort			PORTB				//port for Led 
#define LedDDR			DDRB

#define LedInit()		LedCDDR |=(1<<LED1C|1<<LED2C|1<<LED3C);\
						LedDDR  |=(1<<LED1|1<<LED2|1<<LED3);
						
#define Led1Init()		LedCDDR |= 1<<LED1C;\
						LedDDR  |= 1<<LED1;
#define Led1On()		LedPort |= 1<<LED1;\
						LedCPort &= ~(1<<LED1C);
#define Led1Off()		LedPort &= ~(1<<LED1);
#define Led1Toggle()	LedPort ^= 1<<LED1;

#define Led2Init()		LedCDDR |= 1<<LED2C;\
						LedDDR  |= 1<<LED2;
#define Led2On()		LedPort |= 1<<LED2;\
						LedCPort &= ~(1<<LED2C);
#define Led2Off()		LedPort &= ~(1<<LED2);
#define Led2Toggle()	LedPort ^= 1<<LED2;

#define Led3Init()		LedCDDR |= 1<<LED3C;\
						LedDDR  |= 1<<LED3;
#define Led3On()		LedPort |= 1<<LED3;\
						LedCPort &= ~(1<<LED3C);
#define Led3Off()		LedPort &= ~(1<<LED3);
#define Led3Toggle()	LedPort ^= 1<<LED3;


//___________________USBKeypad definition_________________________________ 
#define right_click		"\2"
#define middle_click	"\4"
#define left_click		"\1"
#define no_click		"\0"
#define Tab				"Doug\r"
#define Enter			"Greg\r"
#define On 				1
#define Off 			0

//These values work for yellow and green leds but blue leds are far less
//sensitive an won't work with these settings.
#define On_level		75
#define Off_level		150
#define max_timeout 	150	




