// SmartkeyV1.1.h
//___________________USB16 Crystal definition_____________________________ 
#ifndef F_CPU
#define F_CPU 16000000
#endif

//___________________USB16 LED definition_________________________________
//Led Cathode bits and J1-5 Cathode (ring)
#define LED1C			6
#define LED2C			4
#define LED3C			5
#define J1C				1
#define J2C				3
#define J3C				0
#define J4C				5
#define J5C				7

//Led Anode bits and J1-5 anode (tip)
#define LED1 			7
#define LED2 			5
#define LED3 			6
#define J1				0
#define J2				2
#define J3				4
#define J4				4
#define J5				6

#define J123Port		PORTD				//port for J1-3 
#define J123DDR			DDRD
#define J45Port			PORTB				//port for J4-5 
#define J45DDR			DDRB

#define LedInit()		DDRC |=(1<<LED1|1<<LED1C|1<<LED2|1<<LED2C);\
						DDRD |=(1<<LED3|1<<LED3C);\

#define Led1Init()		DDRC |= 1<<LED1 | 1<<LED1C;
#define Led1On()		PORTC |= 1<<LED1;\
						PORTC &= ~(1<<LED1C);
#define Led1Off()		PORTC &= ~(1<<LED1);
#define Led1Toggle()	PORTC ^= 1<<LED1;

#define Led2Init()		DDRC |= 1<<LED2 | 1<<LED2C;
#define Led2On()		PORTC |= 1<<LED2;\
						PORTC &= ~(1<<LED2C);
#define Led2Off()		PORTC &= ~(1<<LED2);
#define Led2Toggle()	PORTC ^= 1<<LED2;

#define Led3Init()		DDRD |= 1<<LED3 | 1<<LED3C;
#define Led3On()		PORTD |= 1<<LED3;\
						PORTD &= ~(1<<LED3C);
#define Led3Off()		PORTD &= ~(1<<LED3);
#define Led3Toggle()	PORTD ^= 1<<LED3;

//______________________J1-5 definition___________________________________

#define JInit()			J123DDR |= 1<<J1 | 1<<J2 | 1<<J3 | 1<<J1C | 1<<J2C;\
						J45DDR |= 1<<J4 | 1<<J5 | 1<<J4C | 1<<J5C | 1<<J3C;

#define J1Init()		J123DDR  |= 1<<J1 | 1<<J1C;
#define J1On()			J123Port |= 1<<J1;\
						J123Port &= ~(1<<J1C);
#define J1Off()			J123Port &= ~(1<<J1);
#define J1Toggle()		J123Port ^= 1<<J1;

#define J2Init()		J123DDR  |= 1<<J2 | 1<<J2C;
#define J2On()			J123Port |= 1<<J2;\
						J123Port &= ~(1<<J2C);
#define J2Off()			J123Port &= ~(1<<J2);
#define J2Toggle()		JJ123Port ^= 1<<J2;

#define J3Init()		J123DDR  |= 1<<J3;\
						J45DDR  |= 1<<J3C;
#define J3On()			J123Port |= 1<<J3;\
						J45Port &= ~(1<<J3C);
#define J3Off()			J123Port &= ~(1<<J3);
#define J3Toggle()		J123Port ^= 1<<J3;

#define J4Init()		J45DDR  |= 1<<J4 | 1<<J4C;
#define J4On()			J45Port |= 1<<J4;\
						J45Port &= ~(1<<J4C);
#define J4Off()			J45Port &= ~(1<<J4);
#define J4Toggle()		J45Port ^= 1<<J4;

#define J5Init()		J45DDR |= 1<<J5 | 1<<J5C;
#define J5On()			J45Port |= 1<<J5;\
						J45Port &= ~(1<<J5C);
#define J5Off()			J45Port &= ~(1<<J5);
#define J5Toggle()		J45Port ^= 1<<J5;

//___________________USBKeypad definition_________________________________ 
#define right_click		"\2"
#define middle_click	"\4"
#define left_click		"\1"
#define no_click		"\0"
#define Tab				"Doug\r"
#define Enter			"Greg\r"
#define On 				1
#define Off 			0

#define On_level		75
#define Off_level		150
#define max_timeout 	150




