//___________________USB16 Crystal definition_____________________________ 
#ifndef F_CPU
#define F_CPU 16000000
//#define f_cpu 16
#endif

//___________________USB16 LED definition_________________________________
#define LED1C			3					//port bit for cathode
#define LED1 			6					//port bit for anode
#define LED2 			0					//
#define LED3 			1					//
#define LED4 			2					//
#define LedPort			PORTD				//actual port for Led 
#define LEDDDR			DDRD

#define LedInit()		LEDDDR |=(1<<LED1|1<<LED1C|1<<LED2|1<<LED3|1<<LED4);

#define Led1Init()		LEDDDR |= 1<<LED1 | 1<<LED1C;
#define Led1On()		LedPort |= 1<<LED1;\
						LedPort &= ~(1<<LED1C);
#define Led1Off()		LedPort &= ~(1<<LED1);
#define Led1Toggle()	LedPort ^= 1<<LED1;

#define Led2Init()		LEDDDR |= 1<<LED2;
#define Led2On()		LedPort |= 1<<LED2;
#define Led2Off()		LedPort &= ~(1<<LED2);
#define Led2Toggle()	LedPort ^= 1<<LED2;

#define Led3Init()		LEDDDR |= 1<<LED3;
#define Led3On()		LedPort |= 1<<LED3;
#define Led3Off()		LedPort &= ~(1<<LED3);
#define Led3Toggle()	LedPort ^= 1<<LED3;

#define Led4Init()		LEDDDR |= 1<<LED4;
#define Led4On()		LedPort |= 1<<LED4;
#define Led4Off()		LedPort &= ~(1<<LED4);
#define Led4Toggle()	LedPort ^= 1<<LED4;

#define Backlight_on	LedPort |= 1<<LED2 | 1<<LED3 | 1<<LED4;
#define Backlight_off	LedPort &= ~(1<<LED2 | 1<<LED3 | 1<<LED4);
//___________________USB16 Photosensor definition_________________________ 
#define SensorDDR		DDRD
#define SensorPORT		PORTD
#define SensorPIN		PIND
#define sensor 			1<<LED1C

//___________________AT90USB162 Uart definition___________________________ 
#define SerialPort		PORTD
#define SerialDDR		DDRD
#define RXD				2
#define TXD				3
#define UBRRH			UBRR1H
#define UBRRL			UBRR1H
#define RXC				RXC1
#define TXC				TXC1
#define TXEN			TXEN1
#define RXEN			RXEN1
#define RXCIE			RXCIE1
#define UCSRA			UCSR1A 
#define UCSRB			UCSR1B
#define UDRE			UDRE1 
#define UDR				UDR1

//___________________USBKeypad definition_________________________________ 
#define right_click		"\2"
#define middle_click	"\4"
#define left_click		"\1"
#define no_click		"\0"
#define Tab				"Doug\r"
#define Enter			"Greg\r"
#define On 				1
#define Off 			0

#define On_level		75
#define Off_level		150
#define max_timeout 	150

//Hardware configuration for USB_Keypad V1.1
//PC4-7 are switch inputs
//		SW1 = PC5 	mouse 	0
//		SW2 = PC7  	mouse 	1
//		SW3 = PC6 	keyboard 0
//		SW4 = PC4 	keyboard 1
//Setup all switch and config signals as inputs with pullups
#define Switch_init	DDRC &= ~(1<<DDC4 | 1<<DDC5 | 1<<DDC6 | 1<<DDC7);\
					PORTC |= (1<<DDC4 | 1<<DDC5 | 1<<DDC6 | 1<<DDC7);

#define Read_config	((PINC & (1<<PINC4 | 1<<PINC5 | 1<<PINC6 | 1<<PINC7))>>4)



