/*
 * Led routines
 */
#include "../include/typedefs.h"	//USB16 hardware definition
#define off	0
#define on  1

#ifndef sensor
#define sensor 1<<LEDC
#endif

#define Off_level	144
#define On_level	100				//was 140
#define max_timeout Off_level+1
#define up	1
#define down 0
#define pwm	32

typedef struct{
u08 	on_time;					//led on time in ms
u08		on_cntr;					//actual counter
u08		period;						//period of pulsing, effectively off time
u08		period_cntr;				//actual counter
u08		port;						//ascii letter representing port #
u08		led;						//0..7 representing bit position
u08		duration;					//number of ms between PWM transitions
u08		duration_cntr;				//number of ms between PWM transitions
u08		direction;					//PWM up or down
} S_PulseLed;

void InitTimer(u08 CPU);
void DisplayLED(u08 LED,u08 on_time, u08 period, u08 port,u08 led, u08 dur, u08 dir);
void DisplayOff(u08 LED);
u16 SenseLight(u16 max_level);
u08 KeyPress(void);







